;
; MZ-1M01 IPL-ROM TEST PROGRAM
;
;  KANJI print in 8bit mode
;

	ORG	0B000H
	JP	START
	JP	INIT

;
; Interrupt vector
;
	DW	INTPA
	DW	INTPB

	DS	0B010H-$

;
; KANJI pattern output area
;
OUTBF:	DS	32

;
; Z80A PIO initialize words
;
IOTBL:	DW	0D506H
	DW	0D58FH
	DW	0D587H
	DW	0D708H
	DW	0D7CFH
	DW	0D77FH
	DW	0D797H
	DW	0D7FFH

;
; MAIN ROUTINE
;
; (DE) ... JIS CODE in ASCII string
;
START:	LD	C,0		; get KANJI pattern
	CALL	PUTPA
	XOR	A
	LD	(IFLAGB),A
	LD	B,4
L_CODE:	LD	A,(DE)
	LD	C,A
	INC	DE
	CALL	PUTPA
	DJNZ	L_CODE
	IN	A,(0D4H)	; DUMMY
	LD	HL,OUTBF
	LD	B,32
L_PAT:	CALL	GETPA
	LD	(HL),A
	INC	HL
	DJNZ	L_PAT
	RET

;
; Init PIO and enter 88-IPL debug mode
;
INIT:	DI
	LD	A,0B0H
	LD	I,A
	IM	2
	LD	HL,IOTBL
	LD	B,8
INIL:	LD	A,(HL)
	INC	HL
	LD	C,(HL)
	INC	HL
	OUT	(C),A
	DJNZ	INIL
	EI
	LD	C,1

;
; put 1 byte to 8088
;
PUTPA:	XOR	A
	LD	(IFLAGA),A
	LD	A,C
	OUT	(0D4H),A
CHKPA:	LD	A,(IFLAGA)
	OR	A
	JR	Z,CHKPA
	RET

;
; get 1 byte from 8088
;
GETPA:	LD	A,(IFLAGB)
	OR	A
	JR	Z,GETPA
	XOR	A
	LD	(IFLAGB),A
	IN	A,(0D4H)
	RET

;
; Interrupt hundler for PIO-Aport
;
INTPA:	PUSH	AF
	LD	A,1
	LD	(IFLAGA),A
	POP	AF
	EI
	RETI
IFLAGA:	DB	0

;
; Interrupt hundler for PIO-Bport
;
INTPB:	PUSH	AF
	LD	A,1
	LD	(IFLAGB),A
	POP	AF
	EI
	RETI
IFLAGB:	DB	0

	END	00B1H
