0000                    ;
0000                    ; MZ-1M01 IPL-ROM TEST PROGRAM
0000                    ;
0000                    ;  KANJI print in 8bit mode
0000                    ;
0000
0000                    	ORG	0B000H
B000    C3 40 B0        	JP	START
B003    C3 62 B0        	JP	INIT
B006
B006                    ;
B006                    ; Interrupt vector
B006                    ;
B006    94 B0           	DW	INTPA
B008    9F B0           	DW	INTPB
B00A
B00A    00 00 00 00     	DS	0B010H-$
B00E    00 00
B010
B010                    ;
B010                    ; KANJI pattern output area
B010                    ;
B010    00 00 00 00     OUTBF:	DS	32
B014    00 00 00 00
B018    00 00 00 00
B01C    00 00 00 00
B020    00 00 00 00
B024    00 00 00 00
B028    00 00 00 00
B02C    00 00 00 00
B030
B030                    ;
B030                    ; Z80A PIO initialize words
B030                    ;
B030    06 D5           IOTBL:	DW	0D506H
B032    8F D5           	DW	0D58FH
B034    87 D5           	DW	0D587H
B036    08 D7           	DW	0D708H
B038    CF D7           	DW	0D7CFH
B03A    7F D7           	DW	0D77FH
B03C    97 D7           	DW	0D797H
B03E    FF D7           	DW	0D7FFH
B040
B040                    ;
B040                    ; MAIN ROUTINE
B040                    ;
B040                    ; (DE) ... JIS CODE in ASCII string
B040                    ;
B040    0E 00           START:	LD	C,0		; get KANJI pattern
B042    CD 79 B0        	CALL	PUTPA
B045    AF              	XOR	A
B046    32 A9 B0        	LD	(IFLAGB),A
B049    06 04           	LD	B,4
B04B    1A              L_CODE:	LD	A,(DE)
B04C    4F              	LD	C,A
B04D    13              	INC	DE
B04E    CD 79 B0        	CALL	PUTPA
B051    10 F8           	DJNZ	L_CODE
B053    DB D4           	IN	A,(0D4H)	; DUMMY
B055    21 10 B0        	LD	HL,OUTBF
B058    06 20           	LD	B,32
B05A    CD 87 B0        L_PAT:	CALL	GETPA
B05D    77              	LD	(HL),A
B05E    23              	INC	HL
B05F    10 F9           	DJNZ	L_PAT
B061    C9              	RET
B062
B062                    ;
B062                    ; Init PIO and enter 88-IPL debug mode
B062                    ;
B062    F3              INIT:	DI
B063    3E B0           	LD	A,0B0H
B065    ED 47           	LD	I,A
B067    ED 5E           	IM	2
B069    21 30 B0        	LD	HL,IOTBL
B06C    06 08           	LD	B,8
B06E    7E              INIL:	LD	A,(HL)
B06F    23              	INC	HL
B070    4E              	LD	C,(HL)
B071    23              	INC	HL
B072    ED 79           	OUT	(C),A
B074    10 F8           	DJNZ	INIL
B076    FB              	EI
B077    0E 01           	LD	C,1
B079
B079                    ;
B079                    ; put 1 byte to 8088
B079                    ;
B079    AF              PUTPA:	XOR	A
B07A    32 9E B0        	LD	(IFLAGA),A
B07D    79              	LD	A,C
B07E    D3 D4           	OUT	(0D4H),A
B080    3A 9E B0        CHKPA:	LD	A,(IFLAGA)
B083    B7              	OR	A
B084    28 FA           	JR	Z,CHKPA
B086    C9              	RET
B087
B087                    ;
B087                    ; get 1 byte from 8088
B087                    ;
B087    3A A9 B0        GETPA:	LD	A,(IFLAGB)
B08A    B7              	OR	A
B08B    28 FA           	JR	Z,GETPA
B08D    AF              	XOR	A
B08E    32 A9 B0        	LD	(IFLAGB),A
B091    DB D4           	IN	A,(0D4H)
B093    C9              	RET
B094
B094                    ;
B094                    ; Interrupt hundler for PIO-Aport
B094                    ;
B094    F5              INTPA:	PUSH	AF
B095    3E 01           	LD	A,1
B097    32 9E B0        	LD	(IFLAGA),A
B09A    F1              	POP	AF
B09B    FB              	EI
B09C    ED 4D           	RETI
B09E    00              IFLAGA:	DB	0
B09F
B09F                    ;
B09F                    ; Interrupt hundler for PIO-Bport
B09F                    ;
B09F    F5              INTPB:	PUSH	AF
B0A0    3E 01           	LD	A,1
B0A2    32 A9 B0        	LD	(IFLAGB),A
B0A5    F1              	POP	AF
B0A6    FB              	EI
B0A7    ED 4D           	RETI
B0A9    00              IFLAGB:	DB	0
B0AA
